<?php

class ModelExtensionPaymentEnot extends Model
{
    public function getMethod($address, $total)
    {
        $title = $this->config->get('payment_enot_title');
        return array(
            'code' => 'enot',
            'title' => $title ? $title : 'Enot',
            'terms' => $this->render(),
            'sort_order' => $this->config->get('payment_enot_sort_order')
        );
    }

    private function render()
    {
        require_once __DIR__ . '/enotMerchantAPI.php';
        $enot = new EnotMerchantAPI(
            $this->config->get('payment_enot_secret_word'),
        );
        $request = $enot->buildQuery('shops/' . $this->config->get('payment_enot_merchant_id') . '/payment-tariffs', array());
        if (!$request) die('enot: не получены способы оплаты. Проверьте настройки кассы');

        $data = json_decode($request, true);

        $this->session->data['enot'] = array('allmethods' => array());
        foreach ($data['data']['tariffs'] as $key => $item) {
            if ($item['status'] == "enabled" && $item['min_sum'] <= $this->cart->getTotal() && ($item['service'] != 'card' || $item['currency'] == $this->session->data['currency'])) {
                $this->session->data['enot']['allmethods'][] = $item['service'];
                $data['data']['tariffs'][$key]['commi'] = $item['percent'] * $item['user_percent'] / 100;
            } else unset($data['data']['tariffs'][$key]);
        }

        require_once DIR_APPLICATION . '/controller/extension/payment/enot.php';
        $controller = new ControllerExtensionPaymentEnot($this->registry);
        return $controller->getMethodList($data['data']);
    }

    public function getPaymentUrl()
    {
        $this->load->model('checkout/order');
        $order = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $this->language->load('extension/payment/enot');
        $data = array(
            'order_id' => time() . '_' . $order['order_id'],
            'amount' => $order['total'],
            'currency' => $this->session->data['currency'],
            'shop_id' => $this->config->get('payment_enot_merchant_id'),
            'comment' => $this->language->get('order_description') . $order['order_id']
        );
        if (!empty($this->session->data['enot']['method_current']))
            $data['include_service'] = array($this->session->data['enot']['method_current']);
        else if (empty($this->session->data['enot']['allmethods']))
            die('enot: не получены методы оплаты. Проверьте настройки кассы');

        require_once __DIR__ . '/enotMerchantAPI.php';

        $enot = new EnotMerchantAPI(
            $this->config->get('payment_enot_secret_word'),
        );
        $request = $enot->buildQuery('invoice/create', $data, 'post');

        if (!$request) die('enot: не проходит оплата. Проверьте настройки кассы');

        $request = json_decode($request, true);

        return $request['data']['url'];
    }

}

?>